"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.AnimatedNumber = void 0;

var _react = _interopRequireDefault(require("react"));

var _jsxRuntime = require("react/jsx-runtime");

const AnimatedNumber = ({
  duration = 1000,
  value,
  formatValue = v => `${v}`
}) => {
  const [animatedValue, setAnimatedValue] = _react.default.useState(0);

  const [animateOpt, setAnimateOpt] = _react.default.useState({
    duration,
    toValue: 0,
    startTime: +new Date()
  });

  _react.default.useEffect(() => {
    setAnimateOpt({
      duration,
      toValue: value,
      startTime: +new Date()
    });
  }, [duration, value]);

  _react.default.useEffect(() => {
    if (animatedValue === animateOpt.toValue) return;
    const startTime = animateOpt.startTime;
    const endTime = startTime + animateOpt.duration;
    const now = +new Date();
    const endValue = animateOpt.toValue;
    const nums = (endTime - now) / 1000 * 30 - 2;
    const remaining = endValue - animatedValue;
    const inc = nums > 0 ? remaining / nums : remaining;
    let nextVal = animatedValue + inc;

    if (endTime - now < 50) {
      nextVal = endValue;
    }

    const t = requestAnimationFrame(() => {
      setAnimatedValue(nextVal);
    });
    return () => cancelAnimationFrame(t);
  }, [animateOpt, animatedValue]);

  return /*#__PURE__*/(0, _jsxRuntime.jsx)("span", {
    children: formatValue(animatedValue)
  });
};

exports.AnimatedNumber = AnimatedNumber;