"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var React = _interopRequireWildcard(require("react"));

var _reactDndHtml5Backend = require("react-dnd-html5-backend");

var _reactDndTouchBackend = require("react-dnd-touch-backend");

var _reactDnd = require("react-dnd");

var _useTouchable = require("../../hooks/useTouchable");

var _usePrefersColorScheme = require("../../hooks/usePrefersColorScheme");

var _ChessBoard = require("./ChessBoard");

var _canDrop = _interopRequireDefault(require("./canDrop"));

var _jsxRuntime = require("react/jsx-runtime");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 *
 * DragDropContext
 *
 */
const DragDropContext = props => {
  const touchable = (0, _useTouchable.useTouchable)();
  const colorScheme = (0, _usePrefersColorScheme.usePrefersColorScheme)();
  const {
    redPieces,
    blackPieces,
    kill,
    movePiece,
    turn,
    readonly
  } = props;
  return /*#__PURE__*/(0, _jsxRuntime.jsx)(_reactDnd.DndProvider, {
    backend: touchable ? _reactDndTouchBackend.TouchBackend : _reactDndHtml5Backend.HTML5Backend,
    children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_ChessBoard.ChessBoard, {
      redPieces: redPieces,
      blackPieces: blackPieces,
      kill: kill,
      movePiece: movePiece,
      canDrop: _canDrop.default,
      turn: turn,
      readonly: readonly,
      darkMode: colorScheme === 'dark'
    })
  });
};

var _default = DragDropContext;
exports.default = _default;