"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactDnd = require("react-dnd");

var _react2 = require("@emotion/react");

var _types = require("./types");

var _jsxRuntime = require("@emotion/react/jsx-runtime");

/** @jsxImportSource @emotion/react */
const Piece = ({
  item,
  turn,
  readonly,
  darkMode
}) => {
  const [collected, drag, dragPreview] = (0, _reactDnd.useDrag)(() => ({
    type: _types.ChessPieceDraggalbeType,
    item,

    canDrag() {
      if (readonly) return false;
      return item.color === turn;
    },

    isDragging(monitor) {
      return monitor.getItem().id === item.id;
    },

    collect(monitor) {
      return {
        // You can ask the monitor about the current drag state:
        isDragging: monitor.isDragging()
      };
    }

  }));
  let itemColor = item.color;

  if (darkMode && itemColor === _types.ChessColor.Black) {
    itemColor = 'white';
  }

  return (0, _jsxRuntime.jsx)("div", {
    css: (0, _react2.css)`
        width: 50px;
        height: 50px;
        position: absolute;
        left: 50%;
        top: 50%;
        margin-top: -25px;
        margin-left: -25px;
        font-size: 30px;
        text-align: center;
        line-height: 50px;
        border: 1px solid ${darkMode ? 'white' : 'black'};
        border-radius: 50%;
        background-color: ${darkMode ? 'black' : 'white'};
        user-select: none;
        color: ${itemColor};
      `,
    ref: collected.isDragging ? dragPreview : drag,
    children: item.name
  });
};

var _default = Piece;
exports.default = _default;