"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.throttleRender = exports.default = void 0;

var React = _interopRequireWildcard(require("react"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 *
 * throttleRender
 *
 */
const throttleRender = (throttleTime = 100) => View => {
  class ThrottleView extends React.Component {
    constructor(...args) {
      super(...args);
      this.timer = null;
      this.shouldUpdate = true;
      this.state = {
        count: 0
      };
    }

    shouldComponentUpdate() {
      if (this.shouldUpdate) {
        return true;
      }

      if (this.timer == null) {
        this.timer = setTimeout(() => {
          this.timer = null;
          this.shouldUpdate = true;
          this.setState(sts => ({
            count: sts.count + 1
          }));
        }, throttleTime);
      }

      this.shouldUpdate = false;
      return false;
    }

    componentDidUpdate() {
      this.shouldUpdate = false;

      if (this.timer == null) {
        setTimeout(() => {
          this.shouldUpdate = true;
        }, throttleTime);
      }
    }

    render() {
      return /*#__PURE__*/React.createElement(View, this.props);
    }

  }

  const ThrottledView = props => /*#__PURE__*/React.createElement(ThrottleView, props);

  ThrottledView.displayName = `Throttled${View.displayName ? `(${View.displayName})` : ''}<${throttleTime}>`;
  return ThrottledView;
};

exports.throttleRender = throttleRender;
var _default = throttleRender;
exports.default = _default;