"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useTouchable = exports.default = void 0;

var _react = require("react");

const useTouchable = () => {
  const [touchable, setTouchable] = (0, _react.useState)(false);
  (0, _react.useEffect)(() => {
    if ('ontouchstart' in window.document.documentElement) {
      setTouchable(true);
    } else if (window.navigator.hasOwnProperty('pointerEnabled')) {
      setTouchable(true);
    } else if (window.navigator.hasOwnProperty('msPointerEnabled')) {
      setTouchable(true);
    } else {
      setTouchable(false);
    }
  }, []);
  return touchable;
};

exports.useTouchable = useTouchable;
var _default = useTouchable;
exports.default = _default;