import { ReactChildren, ReactChild } from 'react';
export declare enum ChessColor {
    Black = "black",
    Red = "red"
}
export declare enum PieceType {
    General = 0,
    Advisor = 1,
    Elephant = 2,
    Horse = 3,
    Chariot = 4,
    Cannon = 5,
    Soldier = 6
}
export declare const ChessPieceDraggalbeType = "GSMLG-Chess-Piece";
export declare type PositionShape = {
    x: number;
    y: number;
};
export declare type PieceShape = {
    id: string;
    name: string;
    type: PieceType;
    color: ChessColor;
    position: PositionShape;
    live: boolean;
};
export interface XiangqiState {
    redPieces: PieceShape[];
    blackPieces: PieceShape[];
    turn: ChessColor;
    channel: object | null;
}
export declare type ContainerState = XiangqiState;
export interface DragDropContextProps {
    redPieces: PieceShape[];
    blackPieces: PieceShape[];
    kill: (item: PieceShape) => PieceShape;
    movePiece: (item: PieceShape, pos: PositionShape) => void;
    turn: ChessColor;
    readonly: boolean;
}
export interface ChessBoardProps extends DragDropContextProps {
    canDrop: (item: PieceShape, pos: PositionShape, pieces: PieceShape[]) => boolean;
    darkMode: boolean;
}
export interface SquareProps {
    x: number;
    y: number;
    canDrop: (item: PieceShape, pos: PositionShape, pieces: PieceShape[]) => boolean;
    piece: PieceShape | null | undefined;
    pieces: PieceShape[];
    movePiece: (item: PieceShape, pos: PositionShape) => void;
    kill: () => void;
    children: ReactChild | ReactChildren | null;
    readonly: boolean;
    darkMode: boolean;
}
export interface PieceProps {
    item: PieceShape;
    turn: ChessColor;
    readonly: boolean;
    darkMode: boolean;
}
